/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <stdio.h>
#include <libc/file.h>
#include <unistd.h>

size_t fwrite(const void *const p, const size_t sz, const size_t nmemb,
    FILE *const f)
{
    size_t ret = 0;
    const char *b = p;

    for (size_t i = 0; i < nmemb; i++, ret++)
    {
        size_t rem = sz;

        while (rem)
        {
            const ssize_t n = write(f->fd, b, rem);

            if (n < 0)
            {
                f->error = 1;
                return 0;
            }

            b += n;
            rem -= n;
        }
    }

    return ret;
}
